/*
 * ledControl.h
 *  Controlador del Led de la placa, per executar les solicituds de actuació
 *  sobre el Led.
 *
 *  Created on: 21/5/2015
 *      Author: david
 *
 */

#ifndef FWCSE_X_INC_LEDCONTROL_H_
#define FWCSE_X_INC_LEDCONTROL_H_

/* Configuració de velocitad de intermitencia (en milisegons) del Led de la placa.
 *
 * @precondition 	A la placa 1769 nomes hi ha un Led.
 * 					El parametre es una variable entera en little Indian
 * @param pointer	Apuntador de memoria del parametre.
 * @param mida		Tamany de la variable.
 *
 * @return void
 */
void LedControl_set(int *, unsigned char );

/* Executor de solicituds d'actuacio sobre el Led. Segons l'accio que reb per
 * parametre es fa actual al Led de la placa.
 * @precondition 	A la placa 1769 nomes hi ha un Led.
 * 					S'ha definit la temporitzacio amb LedControl_Set
 * @param pointer	Apuntador de memoria al codi de la solicitud.*
 * @return void
 */
void LedControl_run(unsigned short int action);

#endif /* FWCSE_X_INC_LEDCONTROL_H_ */
