/*
 * ProtocolSE.h
 *
 *  Created on: 20/5/2015
 *      Author: david
 */

#ifndef FWCSE_X_INC_PROTOCOLSE_H_
#define FWCSE_X_INC_PROTOCOLSE_H_

#define ID_PROTOCOL_SE		"SE"

/* Identificadors de dispositius en little Indian*/
#define ID_LED  			0x0101
#define ID_PIN              0x0201
#define ID_ADC  			0x0100
#define ID_UART   			0x1100
#define ID_SPI  			0x2100
#define ID_I2C  			0x3100

/* Identificadors de operacions en little Indian*/
#define ID_ON				0x0100
#define ID_OFF				0x0200
#define ID_BLINK			0x0300
#define ID_GET				0x0101
#define ID_SET				0x0201

/* Valors per defecte */
#define DEFAULT_SPEED		9600

/* Midas de registres i estructures de dades */
#define PAQUET_SIZE_SE		255
#define HEAD_SIZE_SE		10
#define INST_SIZE_SE		5
#define intDataSize			5
#define intSize  			4

union usic{
	unsigned short int		sint;
	unsigned char			ch[2];
};
struct paquetHead {
	union usic    	 		idProtSE;
	unsigned char 			versionProtSE;
	unsigned char	     	paquetCountSE[2];
	unsigned char        	paquetSizeSE;
	unsigned char           indRespotaSE;
	unsigned char           reservedSE[3];
};

struct paquetInstruction {
	union usic				idDispSE;
	union usic				idComandSE;
	unsigned char 			parmCountSE;
};

struct intData {
	unsigned char 			intMidaSE;
	unsigned char			intDadaSE[4];
};
#endif /* FWCSE_X_INC_PROTOCOLSE_H_ */
