/*
 * adcControl.h
 *
 *  Created on: 5/6/2015
 *      Author: david
 *  Control de lectures de dades de sensors a traves del conersor analogic-digital.
 *
 */

#ifndef INC_ADCCONTROL_H_
#define INC_ADCCONTROL_H_

#define ADC_REF_NUM_BITS 	4096
#define ADC_VOLTS		 	3.3

/* Lectura del valors del ADC dels ports seleccionats.
 * Envia les dades llegides al paquet de resposta.
 *
 * @precondition 	Tenir el port connectat a un sensor.
 * 					Haver configurat els ports a llegir.
 * @return void
 */
void adcControl_get();

/* Configuració de la frequencia s'acces al ADC, i dels ports ADC a llegir
 * @precondition 	Parmetres correctes.
 * 					Haver configurat els ports a llegir.
 * @param pointer	Apuntador de memoria al codi de la solicitud.*
 * @return void
 */
void adcControl_set(unsigned char * ptParm, unsigned char size);

/* Possada en marxa del controlador ADC.
 * @precondition 	S'han configurat els paràmetres amb la funció adcControl_set()
 * @param pointer	Codi de la acció a executar.
 * @return void
 */
void adcControl_run(unsigned short int action);

#endif /* INC_ADCCONTROL_H_ */
