/*
 * generate.h
 *
 *  Created on: 21/5/2015
 *      Author: david
 */

#ifndef FWCSE_X_INC_GENERATE_H_
#define FWCSE_X_INC_GENERATE_H_

/* Generador de paquets del protocol CSE. Genera la capcelera amb el cos buit.
 *
 * @precondition 	ProtocolCSE
 * 					Mida màxima de 255 bytes
 * @param numPaquet	Rep el número de paquet a generar.
 * @return void
 */
void newPaquet(unsigned short int);

/* Afegeix el cos a un paquet del proctocol CSE.
 *
 * @precondition 	El paquet conte capcalera.
 * @param 			Nom del dispositiu al que farà referencia el paquet.
 * @return void
 */
void generate_Body(char * disp);

/* Afegeix una dada numerica a un paquet del proctocol CSE.
 *
 * @precondition 	Paquet valid.
 * @param 			Nom del dispositiu al que farà referencia el paquet.
 * @param 			Dada a afegir com a integer de 4 bytes
 * @return void
 */
void generate_Integer( char * disp, int dada );

/* Afegeix una sequencia de bytes com a dades d'un paquet del proctocol CSE.
 *
 * @precondition 	Paquet valid.
 * @param 			Nom del dispositiu al que farà referencia el paquet.
 * @param 			Punter a la sequencia de bytes
 * @param 			Mida en bytes de la seqüencia
 * @return void
 */
void generate_stream(char * disp, char * dada, unsigned char size);

/* Marca el paquet com a confirmació de la solicitud
 *
 * @precondition 	Paquet valid.
 * @return void
 */
void generate_ok(char * disp, char * msg);

/* Marca el paquet com a resposta de error, i afegeix missatge de error
 *
 * @precondition 	Paquet valid.
 * @param 			Punter al string amb el missatge de error
 * @return void
 */
void generate_error(char * disp, char * msg);

/* Envia el paquet en memoria per la UART3.
 *
 * @precondition 	Paquet valid.
 * @return void
 */
void generate_paquetSend();


#endif /* FWCSE_X_INC_GENERATE_H_ */
