/*
 * interpret.c
 *	Analitza els paquets del protocol CSE, i envia les instruccions que contenen
 *	als dispositius destinataris. Tambè genera paquet de resposta.
 *  Created on: 20/5/2015
 *      Author: david
 */
#include "type.h"
#include "LedControl.h"
#include "ProtocolSE.h"
#include "generate.h"
#include "ConfigCSE.h"

/* Conversió de short int a 2 caracters */
static void _usic_to_String( char * str, union usic ent){
	char idDisp[3];
	idDisp[0] = ent.ch[0];
	idDisp[1] = ent.ch[1];
	idDisp[2] = 0;
	strcpy( str, &idDisp);
}

/* Conversió de 2 bytes a short int */
unsigned short int _char2_to_sint(char *str){
	union usic sint;
	sint.ch[0] = str[1];
	sint.ch[1] = str[0];
	return(sint.sint);
}

int _play_action(char * streamComand){
	struct paquetInstruction * comand;
	unsigned char * paquetParmBuffer = 0;
	unsigned char * apParam;
	int paquetNumParms = 0;
	int total=0;
	unsigned char mida= 0;
	comand = (struct paquetInstruction *) streamComand;
	paquetParmBuffer = streamComand;
	paquetParmBuffer += INST_SIZE_SE;
	apParam = paquetParmBuffer;
	total = INST_SIZE_SE;
	if (comand->idDispSE.sint == ID_LED) {
		while ( paquetNumParms < comand->parmCountSE ){
			paquetNumParms++;
			mida = *apParam;
			apParam++;
			LedControl_set( (unsigned int *) apParam, mida);
			total++;
			total += mida;
			apParam+=mida;
		}
		LedControl_run( (unsigned short int) comand->idComandSE.sint );
	}
	else if (comand->idDispSE.sint == ID_PIN){
		while ( paquetNumParms < comand->parmCountSE ){
					paquetNumParms++;
					mida = *apParam;
					apParam++;
					PinControl_set( (unsigned int *) apParam, mida);
					total++;
					total += mida;
					apParam+=mida;
		}
		PinControl_run((unsigned short int)comand->idComandSE.sint);
	}
	else if ( comand->idDispSE.sint == ID_ADC ) {
		while ( paquetNumParms < comand->parmCountSE ){
					paquetNumParms++;
					mida = *apParam;
					apParam++;
					adcControl_set( (unsigned char *) apParam, mida);
					total++;
					total += mida;
					apParam+=mida;
			}
		adcControl_run(comand->idComandSE.sint);
	}
	else if (comand->idDispSE.sint == ID_UART ){
		while ( paquetNumParms < comand->parmCountSE ){
					paquetNumParms++;
					mida = *apParam;
					apParam++;
					uartControl_set( (unsigned int *) apParam, mida);
					total++;
					total += mida;
					apParam+=mida;
		}
		uartControl(comand->idComandSE.sint);
	}
	else if (comand->idDispSE.sint == ID_I2C ){
		i2cControl(comand->idComandSE.sint);
	}
	else if (comand->idDispSE.sint = ID_SPI ){
		spiControl(comand->idComandSE.sint);
	}
	else PrintF_print (3, "Dispositiu desconegut" );
	return total;
}

void Interpret_run(char * stream){
	struct paquetHead * cap;
	char * streamComand;
	char protocol[3];
	unsigned short int num;
	int mida=0;
	int nBytes=0;
	cap =  (struct paquetHead *) stream;
	_usic_to_String((char *)&protocol, cap->idProtSE );
	if (strcmp(&protocol,ID_PROTOCOL_SE) == 0) {
		//Log_log("Prot=SE%u npaq=%u mida=%u]", cap->versionProtSE, cap->paquetCountSE[0] , cap->paquetSizeSE );
		generate_newPaquet(cap->paquetCountSE);
		/* Cos del paquet */
		streamComand = stream;
		streamComand += HEAD_SIZE_SE;
		nBytes = HEAD_SIZE_SE;
		if ( cap->paquetSizeSE > (short int) HEAD_SIZE_SE){
			while(nBytes < cap->paquetSizeSE) {
				mida = _play_action(streamComand);
				nBytes += mida;
			}
			generate_paquetSend();
		} else Log_log("Paquet sense solicituds");
	}
	else Log_log("Protocol desconegut");
}


