/*
 * generate.c
 *
 *  Created on: 21/5/2015
 *      Author: david
 */
#include "type.h"
#include "uart.h"
#include "ProtocolSE.h"
#include "PrintF.h"

char paquetStream[PAQUET_SIZE_SE];
struct paquetHead 		 * cap;
struct paquetInstruction * info;
char            		 * end;
unsigned char            swBodyGenerated;

void generate_newPaquet( char * number){
	char prot[3] = ID_PROTOCOL_SE;
	char * ptrNumber;
	swBodyGenerated = 0;
	cap = (struct paquetHead *) paquetStream;
	cap->idProtSE.ch[0] = prot[0];
	cap->idProtSE.ch[1] = prot[1];
	cap->versionProtSE = 1;
	cap->paquetCountSE[0] = number[0];
	cap->paquetCountSE[1] = number[1];
	cap->paquetSizeSE = HEAD_SIZE_SE;
	cap->indRespotaSE = 0;
	info = (struct paquetInstruction * ) &paquetStream[HEAD_SIZE_SE];
	end = (char * )info;
	*end = 0;
}

void generate_Body(unsigned short int disp){
	char * disp_char;
	disp_char = (char *) &disp;
	info->idDispSE.ch[0] = disp_char[0];
	info->idDispSE.ch[1] = disp_char[1];
	info->idComandSE.ch[0] = 0;
	info->idComandSE.ch[1] = 0;
	info->parmCountSE = 0;
	cap->paquetSizeSE += INST_SIZE_SE;
	end += INST_SIZE_SE;
	swBodyGenerated = 1;
}

void generate_Integer( unsigned short int disp, unsigned int dada ){
	char * bodyStream = (char *) info;
	struct intData * apIntData;
	char * ent;
	char * sal;
	if ( !swBodyGenerated ){
		generate_Body(disp);
	}
	info->parmCountSE++;
	apIntData = (struct intData *) end;
	apIntData->intMidaSE = intSize;
	//apIntData->intDadaSE = dada;
	ent = (char *) &dada;
	sal = (char *) apIntData->intDadaSE;
	sal[0] = ent[0];
	sal[1] = ent[1];
	sal[2] = ent[2];
	sal[3] = ent[3];
	cap->paquetSizeSE += intDataSize;
	end += intDataSize;
	*end = 0;
}

void generate_Stream(unsigned short int disp, char * dada, uint8_t size){
	char * bodyStream = (char *) info;
	int i;
	if ( *bodyStream == 0 ){
		generate_Body(disp);
	}
	*end = size;
	end++;
	for(i=0; i < size;i++){
		end[i] = dada[i];
	}
	end += size;
	cap->paquetSizeSE += size;
	cap->paquetSizeSE++;
	*end = 0;
}

void generate_ok(){
	cap->indRespotaSE = 1;
}

void generate_error(char * msg){
	uint8_t mida;
	cap->indRespotaSE = 2;
	mida = strlen(msg);
	strcpy( end, msg );
	mida++;
	end += mida;
	cap->paquetSizeSE += mida;
	cap->paquetSizeSE++;
	*end = 0;
}

void generate_paquetSend(){
	//PrintF_print(UART3port, (char *)&paquetStream);
	int size;
	size = cap->paquetSizeSE;
	PrintF_stream(UART3port, (char *)&paquetStream, size);
	//Inicialitza body
	swBodyGenerated = 0;
}
