/*
 * i2cControl.c
 *
 *  Created on: 31/5/2015
 *      Author: david
 */

#include "type.h"
#include "LPC17xx.h"
#include "i2c.h"
#include "timer.h"
#include "ProtocolSE.h"

extern volatile uint8_t I2CMasterBuffer[I2C_PORT_NUM][BUFSIZE];
extern volatile uint8_t I2CSlaveBuffer[I2C_PORT_NUM][BUFSIZE];
extern volatile uint32_t I2CReadLength[I2C_PORT_NUM];
volatile uint32_t PORT_USED = 1;
_Bool var;

/** Realitza una espera activa
 * @param	ms		Milisegons aproximats d'espera
 * @return 	void
 */
void _i2cDelayMs(uint32_t ms) {
	int i;
	// Implementació de delayMS. Espera activa.
	// 7140 iterations are 1ms aprox (it's a vulgar implementation)
	for(i=0; i<( ((uint32_t)7140)*ms); i++){
		;
	}
};

void i2cControl(char * action){
	GPIOSetDir(0,22,1);
//TimerInit(0,10000);								//Initialize timer

	I2C1Init(0);										//Initialize I2C
	I2CMasterBuffer[PORT_USED][0] = 0b01001110;			//I2c address = 0x7e (write only)
	I2CWriteLength[PORT_USED] =  2;						//Write length 2 bytes
	I2CReadLength[PORT_USED] = 1;
	while(1)											//infinity loop
	{
		I2CMasterBuffer[PORT_USED][1] = 0xff;			//Set all I2C-ports high
		I2CEngine( PORT_USED );							//Communicate with Ic

		//delayMs(0,100);									//Delay
		_i2cDelayMs(100);
		I2CMasterBuffer[PORT_USED][1] = 0x00;			//Set all I2C-ports low
		I2CMasterBuffer[PORT_USED][2] = 0b01001111; 	//Command to Read
		I2CEngine( PORT_USED );							//Communicate with Ic
		//delayMs(0,100);									//Delay
		_i2cDelayMs(100);
		var = (I2CSlaveBuffer[1][0]);					//
		GPIOSetValue(0,22,var);							//
	}

}



