/*
 * pinControl.c
 *
 *  Created on: 8/6/2015
 *      Author: david
 *  Control del estat dels pins
 */
#include "LPC17xx.h"
#include "FreeRTOS.h"
#include "type.h"
#include "ProtocolSE.h"
#include "GPIO.h"

int countParmPin = 0;
int portPin = 0;
int bitPin = 0;

void PinControl_set(unsigned int * ptParm, unsigned char size){
	countParmPin++;
	if (countParmPin == 1){
		portPin = *ptParm;
	}
	else if (countParmPin == 2){
		bitPin = *ptParm;
	}
}

void PinControl_run(unsigned short int action){
	int estat = 0;
	if ( action == ID_GET ) {
		estat = GPIOGetValue (portPin, bitPin);
		generate_Integer(ID_PIN, estat);
	}
	else if ( action == ID_ON ) {
		GPIOSetDir( portPin, bitPin, 1 );
		GPIOSetValue(portPin, bitPin, HIGH);
	}
	else if ( action == ID_OFF ) {
		GPIOSetDir( portPin, bitPin, 1 );
		GPIOSetValue(portPin, bitPin, LOW);
	}
	else Log_log("Accio incorrecta en LED");
	countParmPin = 0;
}





