/*
 * spiControl.c
 *
 *  Created on: 31/5/2015
 *      Author: david
 */

#include "type.h"
#include "ssp.h"
#include "ProtocolSE.h"
#include "generate.h"

#define BUFFER_SPI_SIZE		16
uint8_t src_addr[BUFFER_SPI_SIZE]; 	//16 byte Write buffer
uint8_t dest_addr[BUFFER_SPI_SIZE]; 	//16 byte Read buffer
uint8_t portnum = 1;

void setSPIPort(uint8_t num){
	portnum = num;
}

void _spiDelayMs(uint32_t ms) {
	int i;
	// Implementació de delayMS. Espera activa.
	// 7140 iterations are 1ms aprox (it's a vulgar implementation)
	for(i=0; i<( ((uint32_t)7140)*ms); i++){
		;
	}
};

void _initSPI(){
    GPIOSetDir(0, 0, 1);
    GPIOSetValue(0, 0, 1);
    SSP1Init();
}

void spiControl(unsigned short int action, char * buffer){
	unsigned short int idDisp = ID_SPI;
	uint32_t size32 = BUFFER_SPI_SIZE;
	uint8_t size8 = BUFFER_SPI_SIZE;
	int i;
	_initSPI();
	if ( action == ID_GET ) {
		SSPReceive(portnum, (uint8_t *)dest_addr, size32);
		generate_Stream( idDisp, &dest_addr, size8);
	}
	else if ( action == ID_SET ) {
		GPIOSetValue(0, 0, 0);
		size8 = buffer[0];
		for(i=1; i <= size8; i++){
			src_addr[i] = buffer[i];
		}
        SSPSend( portnum, (uint8_t *)src_addr, 5 );
        GPIOSetValue(0, 0, 1);
        _spiDelayMs(1000);
	}
}

