#include "LPC17xx.h"
#include "type.h"
#include "uart.h"
#include "string.h"
#include "PrintF.h"
#include "WiFly.h"

#define RST_WIFLY_PIN  						( 5 )
uint8_t myUART;
char resposta[80];

void delayMs(uint32_t ms) {
	int i;
	// Implementació de delayMS. Espera activa.
	// 7140 iterations are 1ms aprox (it's a vulgar implementation)
	for(i=0; i<( ((uint32_t)7140)*ms); i++){
		;
	}
};

char * reset(){

	char literal[80];
	int timeout = 5;
	int port = 3;
	int vel = 9600;
	// El pin 5 del wifly ens permet fer un reset. Hem de fer 1 - 0 – 1.
	// El '0' ha de durar 160us com a mínim, farem 1ms.
	// Important que deixem un '1' després, sino estarà sempre en reset
	// Fem servir pin del led (P0.2 del uC, pin 24 de la LPC1769Board) per fer reset (veure Exemple01)
	// Initialize pin
	LPC_PINCON->PINSEL1 &= ( ~( 3 << 12 ) );
	LPC_GPIO0->FIODIR |= ( 1 << RST_WIFLY_PIN );
	// it made reset at
	LPC_GPIO0->FIOCLR = 1 << RST_WIFLY_PIN;
	delayMs(1);// min 160us
	LPC_GPIO0->FIOSET = 1 << RST_WIFLY_PIN;
	PrintF_start(port, vel);
	// Per rebre el que ens diu el wifly, faig servir el scan del PrintF
	PrintF_scan(myUART, resposta, timeout);
	// Si imprimim el que hem rebut veurem la inicialització del WiFly:
	strcpy(literal, "Reset Wifly");
	PrintF_print(port, literal);
	strcpy( literal, "Resposta del wifly after RST: ");
	PrintF_print(port, literal);
	PrintF_print(port, resposta);
	return (resposta);
}

//initCMD(){
//	char resposta[255];
	//Entrem mode comanda i imprimim respota (per debugar). Veureu que respon “CMD”
	//PrintF_print(0, "$$$", 0);
	// enter in command mode
	//sizeAsk = PrintF_scan(uint8_t myUART, resposta, uint32_t timeout);
	//sprintf(text, "Hem rebut %d chars amb: %s \n", sizeAsk, resposta);
	//UARTprintf(3, text, 0);

//}

void Wifly_init(uint32_t uartId, uint32_t baudRate){
	//char resposta[255];
	// Inicialitzo la UART0 per treballar amb el WiFly
	UARTInit(uartId, baudRate);
	myUART = uartId;
	// Esperar 3s perquè els perifèrics (WiFly) estiguin correctament encessos
	delayMs(3000); // millor si fos espera passiva
	// Reset per començar des de un estat conegut
	reset();
	//initCMD();
	//7. Ara podem demanar la ip amb get ip i fent el parse corresponent
	//UARTprintfln(3, "Demanem la IP ", 0);
	//sizeAsk = WiFly_getIP(resposta); //
	//sprintf(text, "Tenim la IP: %s \n", resposta);
	//UARTprintf(3, text, 0);
}


void Wifly_connect(){
	;
}

void Wifly_getIP(){
	//char buffRx[128];
	// getIp esta implementat com:
	//UARTprintfln(WF_UART, WF_COM_GET_IP, WF_SZ_COM_GET_IP);
	// send command “get ip” with CR+LF “\n”
	//UART0scanf(buffRx, WF_TIMEOUT_GET);
	// wait response from WiFly
	// TODO check the response is valid (!= error)
	// TODO parse 'IP=' line
	;
}

void Wifly_getCanal(){
	;
}

void Wifly_getRSSI(){
	;
}

void Wifly_getTime(){
	;
}


