/*
 * led.c
 *
 *  Created on: 10/3/2015
 *      Author: david
 *  Control del Led de la placa LPC1769
 */
#include "LPC17xx.h"
#include "led.h"
/** Funcinoes de control del led
 *
 * @param ninguno
 *
 * @return void
 */
void led_init(){
		/* Initialise P0_22 for the LED. */
		LPC_PINCON->PINSEL1	&= ( ~( 3 << 12 ) );
		LPC_GPIO0->FIODIR |= ( 1 << mainLED_BIT );
}
void led_on( ){
	LPC_GPIO0->FIOSET = ( 1 << mainLED_BIT );
}
void led_off( ){
	LPC_GPIO0->FIOCLR = ( 1 << mainLED_BIT );
}
void led_toggle( ){
	unsigned long ulLEDState;

		/* Obtain the current P0 state. */
		ulLEDState = LPC_GPIO0->FIOPIN;

		/* Turn the LED off if it was on, and on if it was off. */
		LPC_GPIO0->FIOCLR = ulLEDState & ( 1 << mainLED_BIT );
		LPC_GPIO0->FIOSET = ( ( ~ulLEDState ) & ( 1 << mainLED_BIT ) );
};



