'''
Created on 27/04/2015

@author: david

Classe de estructura dels paquets del Protocol CSE 
'''
import struct
from pyCSE import bodyCSE

class const:
    HEAD_SIZE = 10

'''
Estructura de la capcalera
'''    
class Cap():    
    prot = 'SE'    
    vers = 1
    cont = 1    
    mida = const.HEAD_SIZE
    resp = 0
    res1 = 0
    res2 = 0
    res3 = 0
    
    def __init__(self):      
        pass        
        
    def setCont(self, count):        
        self.cont = count          
            
    def setMida(self, mida):
        mida+=const.HEAD_SIZE
        self.mida = mida    
                
    def getBytes(self):                     
        s = struct.Struct('>3B H 2B 3B' )
        stream = s.pack( ord(self.prot[0]), ord(self.prot[1]), 
                         self.vers,                  
                         self.cont,
                         self.mida, self.resp, 
                         self.res1, self.res2, self.res3 
                         )
        s = struct.Struct('>10B' )           
        # print ('[cap]stream=' + str(s.unpack(stream)) + 'size=' + str(s.size) )
        return stream
    
    def getResposta(self):
        return self.resp
        
        
    def getTramaID(self):
        s = struct.Struct('>3B H' )
        stream = s.pack( ord(self.prot[0]), ord(self.prot[1]), 
                         self.vers, self.cont )
        return stream
        
    def loadBytes(self, byteStream):
        #print ("set bytes[cap]" + str(byteStream))   
        prot, vers, cont,mida, resp, res1, res2, res3 = struct.unpack('>2sB H 2B 3B', byteStream)
        # self.prot = byteStream[0:2].decode('us-ascii','strict')
        self.prot = prot.decode('us-ascii','strict')                        
        self.vers = vers                                
        self.cont = cont        
        self.mida = mida
        self.resp = resp       
        pass

        
class TramaCSE(object):
    '''
    classdocs
    '''
    cap = Cap()
    cos = bodyCSE.Body()

    def __init__(self):        
        '''
        Constructor
        '''
        self.cap = Cap()
        self.cos = bodyCSE.Body()
        pass
     
    def setComponent(self, component):
        self.cos.setComponent(component)

    def setAction(self, action):
        self.cos.setAction(action)
        pass

    def setCont(self, cont):
        self.cap.setCont(cont)

    def addByte(self, num):
        self.cos.addByte(num)
               
    def addNum(self, num):
        self.cos.addNum(num)
        
    def addText(self, text):
        self.cos.addText(text)
        
    def getHead(self):
        return self.cap
                        
    def getBody(self):
        return self.cos
        
    def toBytes(self):
        m = self.cos.getSize()        
        self.cap.setMida(m)              
        trama = self.cap.getBytes() + self.cos.getBytes()
        #s = struct.Struct( str(len(trama)) + 'B')
        #print ('trama stream=' + str(s.unpack(trama)) )
        return trama
    
    def getTramaID(self):
        idTr = self.cap.getTramaID()
        return(idTr)
        
    def loadStream(self, byteStream):
        size = byteStream.__len__()       
        self.cap.loadBytes(byteStream[0:const.HEAD_SIZE])
        if (byteStream.__len__() > const.HEAD_SIZE):
            self.cos.loadBytes(byteStream[const.HEAD_SIZE:size])                     
        pass
     
    def size(self):    
        size = self.cap.mida
        return size
       
        